/*********************************************************************************************************************
* AI8051U Opensourec Library AI8051U Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļSTC Դһ
*
* AI8051U Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MDK FOR C251
* ƽ̨          AI8051U
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                          ע
* 2024-08-01        W            first version
********************************************************************************************************************/
/*********************************************************************************************************************
* ߶壺
*                   ------------------------------------
*                   ģܽ            Ƭܽ
*                   RX                  鿴 zf_device_wireless_ble6a20.h  BLE6A20_RX_PIN  궨
*                   TX                  鿴 zf_device_wireless_ble6a20.h  BLE6A20_TX_PIN  궨
*                   RTS                 鿴 zf_device_wireless_ble6a20.h  BLE6A20_RTS_PIN 궨
*                   VCC                 3.3VԴ
*                   GND                 Դ
*                   
*                   ------------------------------------
*********************************************************************************************************************/

#include "zf_device_ble6a20.h"
#include "zf_common_clock.h"
#include "zf_common_debug.h"
#include "zf_common_fifo.h"
#include "zf_driver_delay.h"
#include "zf_driver_gpio.h"
#include "zf_driver_uart.h"
#include "zf_device_type.h"

#pragma warning disable = 183
#pragma warning disable = 177

static  fifo_struct                                     ble6a20_fifo;
static  uint8                                           ble6a20_buffer[BLE6A20_BUFFER_SIZE];




//-------------------------------------------------------------------------------------------------------------------
//      תģ 
// ˵     data            8bit 
// ز     uint32          ʣ෢ͳ 0- 1-δ
// ʹʾ     ble6a20_send_byte(data);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint32 ble6a20_send_byte (const uint8 dat)
{
    uint16 time_count = BLE6A20_TIMEOUT_COUNT;
    
    while(time_count)
    {
        if(!gpio_get_level(BLE6A20_RTS_PIN))
        {
            uart_write_byte(BLE6A20_INDEX, dat);                         // 
            break;
        }
        
        time_count --;
        system_delay_ms(1);
    }
    
    return (0 == time_count);
}

//-------------------------------------------------------------------------------------------------------------------
//      תģ ݿ
// ˵     *buff           ͻ
// ˵     len             ݳ
// ز     uint32          ʣ෢ͳ
// ʹʾ     ble6a20_send_buffer(buff, 64);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint32 ble6a20_send_buffer (const uint8 *buff, uint32 len)
{
    uint16 time_count = 0;
    zf_assert(NULL != buff);
    
    while(0 != len)
    {
        if(!gpio_get_level(BLE6A20_RTS_PIN))                              // RTSΪ͵ƽ 
        {
            if(30 <= len)                                                       // ݷ 30byte ÿ
            {
                uart_write_buffer(BLE6A20_INDEX, buff, 30);               // 
                buff += 30;                                                     // ַƫ
                len -= 30;                                                      // 
                time_count = 0;
            }
            else                                                                //  30byte һԷ
            {
                uart_write_buffer(BLE6A20_INDEX, buff, (uint16)len);              // 
                len = 0;
                break;
            }
        }
        else                                                                    // RTSΪߵƽ ģæ
        {
            if(BLE6A20_TIMEOUT_COUNT <= (++ time_count))                  // ȴʱ
            {
                break;                                                          // ˳
            }
            
            system_delay_ms(1);
        }
    }
    
    return len;
}

//-------------------------------------------------------------------------------------------------------------------
//      תģ ַ
// ˵     *str            Ҫ͵ַַ
// ز     uint32          ʣ෢ͳ
// ʹʾ     ble6a20_send_string("Believe in yourself.");
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint32 ble6a20_send_string (const char *str)
{
    uint16 time_count = 0;
    uint32 len = strlen(str);
    uint8 temp[128] = {0};
    zf_assert(NULL != str);
    
    while(0 != len)
    {
        if(!gpio_get_level(BLE6A20_RTS_PIN))                              // RTSΪ͵ƽ 
        {
            if(128 <= len)                                                       // ݷ 128byte ÿ
            {
                memcpy(temp, str, 128);
                uart_write_buffer(BLE6A20_INDEX, temp, 128); // 
                str += 128;                                                      // ַƫ
                len -= 128;                                                      // 
                time_count = 0;
            }
            else                                                                //  128byte һԷ
            {
                memcpy(temp, str, (uint16)len);
                uart_write_buffer(BLE6A20_INDEX, temp, (uint16)len);// 
                len = 0;
                break;
            }
        }
        else                                                                    // RTSΪߵƽ ģæ
        {
            if(BLE6A20_TIMEOUT_COUNT <= (++ time_count))                  // ȴʱ
            {
                break;                                                          // ˳
            }
            
            system_delay_ms(1);
        }
    }
    
    return len;
}


//-------------------------------------------------------------------------------------------------------------------
//      תģ ȡ
// ˵     *buff           ջ
// ˵     len             ȡݳ
// ز     uint32          ʵʶȡݳ
// ʹʾ     ble6a20_read_buffer(buff, 32);
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint32 ble6a20_read_buffer (uint8 *buff, uint32 len)
{
    uint32 data_len = len;
    zf_assert(NULL != buff);
    fifo_read_buffer(&ble6a20_fifo, buff, &data_len, FIFO_READ_AND_CLEAN);
    return data_len;
}

//-------------------------------------------------------------------------------------------------------------------
//      תģ жϻص
// ˵     void
// ز     void
// ʹʾ     ble6a20_callback();
// עϢ     ú ISR ļ жϳ򱻵
//              ɴжϷ wireless_module_uart_handler() 
//               wireless_module_uart_handler() ñ
//-------------------------------------------------------------------------------------------------------------------
void ble6a20_callback (uint8 uart_dat)
{
//    uart_query_byte(BLE6A20_INDEX, &ble6a20_data);
    fifo_write_buffer(&ble6a20_fifo, &uart_dat, 1);
}

//-------------------------------------------------------------------------------------------------------------------
//      תģ ʼ
// ˵     void
// ز     void
// ʹʾ     ble6a20_init();
// עϢ
//-------------------------------------------------------------------------------------------------------------------
uint8 ble6a20_init (void)
{
    uint8 return_state = 0;
    
    // ȴģʼ
    system_delay_ms(50);
    
    set_wireless_type(BLE6A20, BLE6A20_INDEX, ble6a20_callback);
    
    fifo_init(&ble6a20_fifo, FIFO_DATA_8BIT, ble6a20_buffer, BLE6A20_BUFFER_SIZE);
    gpio_init(BLE6A20_RTS_PIN, GPIO, GPIO_HIGH, GPIO_NO_PULL);
    
    // ʹõĲΪ115200 ΪתģĬϲ ģ鲢޸ĴڵĲ
    uart_init (BLE6A20_INDEX, BLE6A20_BUAD_RATE, BLE6A20_RX_PIN, BLE6A20_TX_PIN);   // ʼ
    uart_rx_interrupt(BLE6A20_INDEX, 1);
    
    return return_state;
}
