/*********************************************************************************************************************
* AI8051U Opensourec Library AI8051U Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļSTC Դһ
*
* AI8051U Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MDK FOR C251
* ƽ̨          AI8051U
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                          ע
* 2024-08-01        W            first version
********************************************************************************************************************/

#include "zf_common_debug.h"
#include "zf_driver_adc.h"


static uint8 adc_resolution = {ADC_12BIT};


//-------------------------------------------------------------------------------------------------------------------
//      ADCתNΣƽֵ˲
// ˵     ch              ѡADCͨ
// ˵     resolution      ֱ(8λ 10λ 12λ)
// ˵     count           ת
// ز     void
// ʹʾ     adc_mean_filter(ADC_IN0_A0, ADC_8BIT,5);  //ɼA0˿ڷ8λֱʵADֵɼȡƽֵ
//-------------------------------------------------------------------------------------------------------------------
uint16 adc_mean_filter_convert (adc_channel_enum ch, const uint8 count)
{
    uint8 i;
    uint32 sum;

	zf_assert(count);//ԴΪ0
	
    sum = 0;
    for(i=0; i<count; i++)
    {
        sum += adc_convert(ch);
    }

    sum = sum/count;
    return sum;
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      ADCתһ
//  @param      adcn            ѡADCͨ
//  @param      resolution      ֱ
//  @return     void
//  Sample usage:               adc_convert(ADC_P10, ADC_10BIT);
//-------------------------------------------------------------------------------------------------------------------
uint16 adc_convert(adc_channel_enum ch)
{
    uint16 adc_value;
    
    ADC_CONTR &= (0xF0);			//ADC_CHS[3:0]  ADC ģͨѡλ
    ADC_CONTR |= ch;
    
    ADC_CONTR |= 0x40;  			//  AD ת
    
    while (!(ADC_CONTR & 0x20));  	// ѯ ADC ɱ־
    
    ADC_CONTR &= ~0x20;  			// ɱ־
    
    adc_value = ADC_RES;  			//洢 ADC  12 λĸ 4 λ
    adc_value <<= 8;
    adc_value |= ADC_RESL;  		//洢 ADC  12 λĵ 8 λ
    
    ADC_RES = 0;
    ADC_RESL = 0;
    
    adc_value >>= adc_resolution;	//ȡλ
    
    
    return adc_value;
}

//-------------------------------------------------------------------------------------------------------------------
//      ADCʼ
// ˵     ch      			ch(ѡΧzf_adc.hadc_channel_enumöֵȷ)
// ˵     resolution       resolution(ѡΧzf_adc.hadc_resolution_enumöֵȷ)
// ز     void
// ʹʾ     adc_init(ADC_P10, ADC_12BIT);//ʼP10ΪADCܣ12λֱ
//-------------------------------------------------------------------------------------------------------------------
void adc_init(adc_channel_enum ch, adc_resolution_enum resolution)
{
    ADC_CONTR |= 1 << 7;				//1  ADC Դ
    
    ADC_CONTR &= (0xF0);			//ADC_CHS[3:0]  ADC ģͨѡλ
    ADC_CONTR |= ch;
    
    if((ch >> 3) == 1) //P0.0
    {
        //IOҪΪ
        P0M0 &= ~(1 << (ch & 0x07));
        P0M1 |= (1 << (ch & 0x07));
    }
    else if((ch >> 3) == 0) //P1.0
    {
        //IOҪΪ
        P1M0 &= ~(1 << (ch & 0x07));
        P1M1 |= (1 << (ch & 0x07));
    }
    
    ADCCFG |= ADC_SYSclk_DIV_16 & 0x0F;			//ADCʱƵSYSclk/16&0x0F;
    
    ADCCFG |= 1 << 5;							//תҶ롣 ADC_RES ĸ 2 λ ADC_RESL ĵ 8 λ
	
	adc_resolution = resolution;           // ¼ADC ڲɼʱʹ
}