/*********************************************************************************************************************
* AI8051U Opensourec Library AI8051U Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļSTC Դһ
*
* AI8051U Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MDK FOR C251
* ƽ̨          AI8051U
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                          ע
* 2024-08-01        W            first version
********************************************************************************************************************/

#include "zf_common_clock.h"
#include "zf_driver_eeprom.h"
#include "zf_driver_delay.h"

//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROM
//  @param
//  @return     void
//  Sample usage:       		ڲʹû
//-------------------------------------------------------------------------------------------------------------------
void eeprom_trig(void)
{

    IAP_TRIG = 0x5A;
    IAP_TRIG = 0xA5;                    //5AHA5HIAPĴÿζҪ
    //A5HIAP
    //CPUȴIAPɺ󣬲Żִг
    _nop_();   //STC32GǶ༶ˮߵָϵͳ4NOP֤IAP_DATA׼
    _nop_();
    _nop_();
    _nop_();

}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ʼEEPROM
//  @param      NULL
//  @return     void
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void iap_init(void)
{
    IAP_CONTR = 0x80;	 	//ʹEEPROM
    iap_set_tps();			//òȴʱ
}

//-------------------------------------------------------------------------------------------------------------------
//  @brief      رEEPROM
//  @param      NULL
//  @return     void
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void iap_idle(void)
{
    IAP_CONTR = 0;			//ʧEEPROM
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      ȡEEPROMʧ״̬λҪ
//  @param      NULL
//  @return     void
//  Sample usage:
//								ʧܷ1;
//-------------------------------------------------------------------------------------------------------------------
uint8 iap_get_cmd_state(void)
{
    return ((IAP_CONTR & 0x01) == 0x01);
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      IAPȴʱ
//  @param      NULL
//  @return     void
//  Sample usage:
//-------------------------------------------------------------------------------------------------------------------
void iap_set_tps(void)
{
    uint8 write_time;
    write_time = (system_clock / 1000000) ;
    IAP_TPS = write_time + 1;
}

//-------------------------------------------------------------------------------------------------------------------
//      EEPROMһֽ
// ˵     addr 		Ҫĵַ
// ز     uint8		ȡֵ
//          
// ʹʾ  
//          
//-------------------------------------------------------------------------------------------------------------------
uint8 iap_read_byte(uint32 addr)
{
	uint8 temp;
	bit flag = 0;
	flag = EA;
	EA = 0;
	
    IAP_CMD = 1; 				// IAP 

	IAP_ADDRL = addr; 		// IAP ͵ַ
	IAP_ADDRH = addr >> 8; 	// IAP ߵַ
	IAP_ADDRE = addr >> 16;	// IAP ߵַ
	eeprom_trig();
	temp = IAP_DATA; 		// IAP 

    EA = flag;
	return temp;
}

//-------------------------------------------------------------------------------------------------------------------
//      EEPROMдһֽ
// ˵     addr 		Ҫĵַ
// ز     uint8		ȡֵ
//          
// ʹʾ  
//          
//-------------------------------------------------------------------------------------------------------------------
void iap_write_byte(uint32 addr, uint8 byte)
{
	bit flag = 0;

	flag = EA;
	EA = 0;

	IAP_CMD = 2; 			//  IAP д

	IAP_ADDRL = addr; 		//  IAP ͵ַ
	IAP_ADDRH = addr >> 8; 	//  IAP ߵַ
	IAP_ADDRE = addr >> 16;	//  IAP ߵַ
	IAP_DATA = byte; 		// д IAP 

	eeprom_trig();

	EA = flag;
}
	
//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROMȡֽ
//  @param      addr			Ҫȡeepromַ
//  @param      *buf			Ҫȡݵַ
//  @param      len				Ҫȡݳ
//  @return     void
//  Sample usage:               uint8 str[10];
//								iap_read_bytes(0x00,str,10);
//								0x00-0x0AַеݣȡstrС
//-------------------------------------------------------------------------------------------------------------------
void iap_read_buff(uint32 addr, uint8 *buf, uint16 len)
{
    while(len--)
    {
        *buf++ = iap_read_byte(addr); 		// IAP 
        addr++;
    }
}


//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROMдֽ
//  @param      addr			Ҫдeepromַ
//  @param      *buf			Ҫдݵַ
//  @param      len				Ҫдݳ
//  @return     void
//  Sample usage:       		iap_write_bytes(0x00,(uint8 *)"0123456789",10);
//								"0123456789"д0x00-0x0Aַ;
//-------------------------------------------------------------------------------------------------------------------
void iap_write_buff(uint32 addr, uint8 *buf, uint16 len)
{
	while(len--)
    {
        iap_write_byte(addr, *buf); 		// IAP 
        addr++;
		buf++;
    }
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      EEPROMĿַڵһҳ1/512ֽڣ
//  @param      addr			Ҫдeepromַ
//  @return     void
//  Sample usage:       		iap_erase_page(0x20);
//								0x00-0x200
//-------------------------------------------------------------------------------------------------------------------
void iap_erase_page(uint32 addr)
{
	bit flag = 0;

	flag = EA;
	EA = 0;
    IAP_CMD = 3; 				// IAP 
    IAP_ADDRL = addr; 			// IAP ͵ַ
    IAP_ADDRH = addr >> 8;  	// IAP ߵַ
    IAP_ADDRE = addr >> 16;		// IAP ߵַ
    eeprom_trig();
    
   	EA = flag;
    system_delay_ms(10);		//1(512ֽ)Լ4-6ms
}



//-------------------------------------------------------------------------------------------------------------------
//  @brief      չEEPROMдֽ()
//  @param      addr			Ҫдeepromַ
//  @param      *buf			Ҫдݵַ
//  @param      len				Ҫдݳ
//  @return     void
//  Sample usage:       		extern_iap_write_bytes(0x0000,(uint8 *)"0123456789",10);
//								"0123456789"д0x00-0x0Aַ;
//	@note						Ҫʹá
//								addrַ0-511Ϊһ,512-1023Ϊһ1024-1535Ϊһơ
//-------------------------------------------------------------------------------------------------------------------
void extern_iap_write_buff(uint16 addr, uint8 *buf, uint16 len)
{
    uint8 temp[512] = {0};
    uint16 i;
    
    for(i = 0; i < 512 ; i++)	temp[i] = 0;						//0
    
    iap_read_buff(addr & 0xFE00, temp, 512);						//ȡ
    
    for(i = 0; i < len; i++)	temp[(addr & 0x1FF) + i] = buf[i];	//
    
    iap_erase_page(addr);											//
    iap_write_buff(addr & 0xFE00, temp, 512);					//д
}


