/*********************************************************************************************************************
* AI8051U Opensourec Library AI8051U Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļSTC Դһ
*
* AI8051U Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MDK FOR C251
* ƽ̨          AI8051U
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                          ע
* 2024-08-01        W            first version
********************************************************************************************************************/

#include "zf_common_debug.h"
#include "zf_driver_gpio.h"






// ڲʹãûġ
static void gpio_set_mode(gpio_pin_enum pin, gpio_mode_enum mode)
{
	#define PXPU(pin)  (*(unsigned char volatile far *)(0x7efe10 + (pin >> 4 - 1)))
	#define PXPD(pin)  (*(unsigned char volatile far *)(0x7efe40 + (pin >> 4 - 1)))

	
    if(GPI_FLOATING_IN == mode || GPIO_NO_PULL == mode)
    {
        PXPU(pin) &= ~(1 << (pin & 0x0F));
        PXPD(pin) &= ~(1 << (pin & 0x0F));
    }
    else if(GPI_PULL_DOWN == mode)
    {
        PXPD(pin) |= (1 << (pin & 0x0F));
    }
    else if(GPI_PULL_UP == mode || GPO_PUSH_PULL == mode)
    {
        PXPU(pin) |= (1 << (pin & 0x0F));
    }
	else if(GPO_OPEN_DTAIN == mode)
	{
		switch(pin & 0xF0)
		{
			case IO_P00:
			{
                P0M1 |= (1 << (pin & 0xF));
                P0M0 |= (1 << (pin & 0xF));
			}
			break;

			case IO_P10:
			{
				P1M1 |= (1 << (pin & 0xF));
                P1M0 |= (1 << (pin & 0xF));
			}
			break;
			
			case IO_P20:
			{
				P2M1 |= (1 << (pin & 0xF));
                P2M0 |= (1 << (pin & 0xF));
			}
			break;
			
			case IO_P30:
			{
				P3M1 |= (1 << (pin & 0xF));
                P3M0 |= (1 << (pin & 0xF));
			}
			break;
			
			case IO_P40:
			{
				P4M1 |= (1 << (pin & 0xF));
                P4M0 |= (1 << (pin & 0xF));
			}
			break;
			
			case IO_P50:
			{
				P5M1 |= (1 << (pin & 0xF));
                P5M0 |= (1 << (pin & 0xF));
			}
			break;
			default:
			{
			}	
			break;
		}
	}
	else
	{
		zf_assert(0);
		// ƥ
	}
}

// ڲʹãûġ
void gpio_set_level_speed(gpio_pin_enum pin, gpio_speed_enum speed)
{
    switch(pin & 0xF0)
    {
        case IO_P00:
        {
            if(GPIO_SPEED_FAST == speed)
            {
				P0SR &= ~(1<<(pin & 0x0F));
            }
            else if(GPIO_SPEED_LOW == speed)
            {
				P0SR |= (1<<(pin & 0x0F));
            }
			else
			{
				zf_assert(0);
				// û
			}
        }
        break;
        
        case IO_P10:
        {
            if(GPIO_SPEED_FAST == speed)
            {
				P1SR &= ~(1<<(pin & 0x0F));
            }
            else if(GPIO_SPEED_LOW == speed)
            {
				P1SR |= (1<<(pin & 0x0F));
            }
			else
			{
				zf_assert(0);
				// û
			}
        }
        break;
        
        case IO_P20:
        {
            if(GPIO_SPEED_FAST == speed)
            {
				P2SR &= ~(1<<(pin & 0x0F));
            }
            else if(GPIO_SPEED_LOW == speed)
            {
				P2SR |= (1<<(pin & 0x0F));
            }
			else
			{
				zf_assert(0);
				// û
			}
        }
        break;
        
        case IO_P30:
        {
            if(GPIO_SPEED_FAST == speed)
            {
				P3SR &= ~(1<<(pin & 0x0F));
            }
            else if(GPIO_SPEED_LOW == speed)
            {
				P3SR |= (1<<(pin & 0x0F));
            }
			else
			{
				zf_assert(0);
				// û
			}
        }
        break;
        
        case IO_P40:
        {
			if(GPIO_SPEED_FAST == speed)
            {
				P4SR &= ~(1<<(pin & 0x0F));
            }
            else if(GPIO_SPEED_LOW == speed)
            {
				P4SR |= (1<<(pin & 0x0F));
            }
			else
			{
				zf_assert(0);
				// û
			}
        }
        break;
        
        case IO_P50:
        {
            if(GPIO_SPEED_FAST == speed)
            {
				P5SR &= ~(1<<(pin & 0x0F));
            }
            else if(GPIO_SPEED_LOW == speed)
            {
				P5SR |= (1<<(pin & 0x0F));
            }
			else
			{
				zf_assert(0);
				// û
			}
        }
        break;
        
        default:
        {
			zf_assert(0);
			// û
        } break;
    }
}


// ڲʹãûġ
static void gpio_set_dir(gpio_pin_enum pin, gpio_dir_enum dir)
{
    switch(pin & 0xF0)
    {
        case IO_P00:
        {
            if(GPIO == dir)
            {
                P0M1 &= ~(1 << (pin & 0xF));
                P0M0 &= ~(1 << (pin & 0xF));
            }
//            else if(GPO_OPEN_DTAIN == dir)
//            {
//                P0M1 |= (1 << (pin & 0xF));
//                P0M0 |= (1 << (pin & 0xF));
//            }
            else if(GPO == dir)
            {
                P0M1 &= ~(1 << (pin & 0xF));
                P0M0 |= (1 << (pin & 0xF));
            }
            else if(GPI == dir)
            {
                P0M1 |= (1 << (pin & 0xF));
                P0M0 &= ~(1 << (pin & 0xF));
            }
        }
        break;
        
        case IO_P10:
        {
            if(GPIO == dir)
            {
                P1M1 &= ~(1 << (pin & 0xF));
                P1M0 &= ~(1 << (pin & 0xF));
            }
//            else if(GPO_OPEN_DTAIN == dir)
//            {
//                P1M1 |= (1 << (pin & 0xF));
//                P1M0 |= (1 << (pin & 0xF));
//            }
            else if(GPO == dir)
            {
                P1M1 &= ~(1 << (pin & 0xF));
                P1M0 |= (1 << (pin & 0xF));
            }
            else if(GPI == dir)
            {
                P1M1 |= (1 << (pin & 0xF));
                P1M0 &= ~(1 << (pin & 0xF));
            }
        }
        break;
        
        case IO_P20:
        {
            if(GPIO == dir)
            {
                P2M1 &= ~(1 << (pin & 0xF));
                P2M0 &= ~(1 << (pin & 0xF));
            }
//            else if(GPO_OPEN_DTAIN == dir)
//            {
//                P2M1 |= (1 << (pin & 0xF));
//                P2M0 |= (1 << (pin & 0xF));
//            }
            else if(GPO == dir)
            {
                P2M1 &= ~(1 << (pin & 0xF));
                P2M0 |= (1 << (pin & 0xF));
            }
            else if(GPI == dir)
            {
                P2M1 |= (1 << (pin & 0xF));
                P2M0 &= ~(1 << (pin & 0xF));
            }
        }
        break;
        
        case IO_P30:
        {
            if(GPIO == dir)
            {
                P3M1 &= ~(1 << (pin & 0xF));
                P3M0 &= ~(1 << (pin & 0xF));
            }
//            else if(GPO_OPEN_DTAIN == dir)
//            {
//                P3M1 |= (1 << (pin & 0xF));
//                P3M0 |= (1 << (pin & 0xF));
//            }
            else if(GPO == dir)
            {
                P3M1 &= ~(1 << (pin & 0xF));
                P3M0 |= (1 << (pin & 0xF));
            }
            else if(GPI == dir)
            {
                P3M1 |= (1 << (pin & 0xF));
                P3M0 &= ~(1 << (pin & 0xF));
            }
        }
        break;
        
        case IO_P40:
        {
            if(GPIO == dir)
            {
                P4M1 &= ~(1 << (pin & 0xF));
                P4M0 &= ~(1 << (pin & 0xF));
            }
//            else if(GPO_OPEN_DTAIN == dir)
//            {
//                P4M1 |= (1 << (pin & 0xF));
//                P4M0 |= (1 << (pin & 0xF));
//            }
            else if(GPO == dir)
            {
                P4M1 &= ~(1 << (pin & 0xF));
                P4M0 |= (1 << (pin & 0xF));
            }
            else if(GPI == dir)
            {
                P4M1 |= (1 << (pin & 0xF));
                P4M0 &= ~(1 << (pin & 0xF));
            }
        }
        break;
        
        case IO_P50:
        {
            if(GPIO == dir)
            {
                P5M1 &= ~(1 << (pin & 0xF));
                P5M0 &= ~(1 << (pin & 0xF));
            }
//            else if(GPO_OPEN_DTAIN == dir)
//            {
//                P5M1 |= (1 << (pin & 0xF));
//                P5M0 |= (1 << (pin & 0xF));
//            }
            else if(GPO == dir)
            {
                P5M1 &= ~(1 << (pin & 0xF));
                P5M0 |= (1 << (pin & 0xF));
            }
            else if(GPI == dir)
            {
                P5M1 |= (1 << (pin & 0xF));
                P5M0 &= ~(1 << (pin & 0xF));
            }
        }
        break;
        
        default:
        {
			zf_assert(0);
			// û
        } break;
    }
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIO״̬ȡ
// ˵     pin         ѡ (ѡΧ zf_driver_gpio.h gpio_pin_enumöֵȷ)
// ز     uint8       0͵ƽ 1ߵƽ
// ʹʾ     uint8 status = gpio_get_level(IO_P00);//ȡP00ŵƽ
//-------------------------------------------------------------------------------------------------------------------
uint8 gpio_get_level(gpio_pin_enum pin)
{
    uint8 status = 0;
    
    switch(pin & 0xF0)
    {
        case IO_P00:
        {
            status = P0 & (1 << (pin & 0x0F));
        }
        break;
        
        case IO_P10:
        {
            status = P1 & (1 << (pin & 0x0F));
        }
        break;
        
        case IO_P20:
        {
            status = P2 & (1 << (pin & 0x0F));
        }
        break;
        
        case IO_P30:
        {
            status = P3 & (1 << (pin & 0x0F));
        }
        break;
        
        case IO_P40:
        {
            status = P4 & (1 << (pin & 0x0F));
        }
        break;
        
        case IO_P50:
        {
            status = P5 & (1 << (pin & 0x0F));
        }
        break;
        
        default:
        {
			zf_assert(0);
			// û
        } break;
    }
    
    return status ? 1 : 0;
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIO
// ˵     pin         źѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ˵     dat         ŵĵƽ״̬ʱЧ 0͵ƽ 1ߵƽ
// ز     void
// ʹʾ     gpio_set_level(D0, 0);//D0͵ƽ
//-------------------------------------------------------------------------------------------------------------------
void gpio_set_level(gpio_pin_enum pin, uint8 dat)
{
    switch(pin & 0xF0)
    {
        case IO_P00:
        {
			if(dat)
			{
				P0 |= (1 << (pin & 0x0F));
			}
			else
			{
				P0 &= ~(1 << (pin & 0x0F));
			}
        }
        break;
        
        case IO_P10:
        {
			if(dat)
			{
				P1 |= (1 << (pin & 0x0F));
			}
			else
			{
				P1 &= ~(1 << (pin & 0x0F));
			}
        }
        break;
        
        case IO_P20:
        {
			if(dat)
			{
				P2 |= (1 << (pin & 0x0F));
			}
			else
			{
				P2 &= ~(1 << (pin & 0x0F));
			}
        }
        break;
        
        case IO_P30:
        {
			if(dat)
			{
				P3 |= (1 << (pin & 0x0F));
			}
			else
			{
				P3 &= ~(1 << (pin & 0x0F));
			}
        }
        break;
        
        case IO_P40:
        {
			if(dat)
			{
				P4 |= (1 << (pin & 0x0F));
			}
			else
			{
				P4 &= ~(1 << (pin & 0x0F));
			}
        }
        break;
        
        case IO_P50:
        {
			if(dat)
			{
				P5 |= (1 << (pin & 0x0F));
			}
			else
			{
				P5 &= ~(1 << (pin & 0x0F));
			}
        }
        break;
        
        default:
        {
			zf_assert(0);
			// û
        } break;
    }
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIO
// ˵     pin         źѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ˵     dat         ŵĵƽ״̬ʱЧ 0͵ƽ 1ߵƽ
// ز     void
// ʹʾ     gpio_set_level(D0, 0);//D0͵ƽ
//-------------------------------------------------------------------------------------------------------------------
void gpio_toggle_level(gpio_pin_enum pin)
{
	if(gpio_get_level(pin))
	{
		gpio_low(pin);
	}
	else
	{
		gpio_high(pin);
	}
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIOø
// ˵     pin         źѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ز     void
// ʹʾ     
//-------------------------------------------------------------------------------------------------------------------
void gpio_set_impedance(gpio_pin_enum pin)
{
    switch(pin & 0xF0)
    {
        case IO_P00:
        {
			P0M1 |=  (1 << (pin & 0xF));
			P0M0 &= ~(1 << (pin & 0xF));
        }
        break;
        
        case IO_P10:
        {
			P1M1 |=  (1 << (pin & 0xF));
			P1M0 &= ~(1 << (pin & 0xF));
        }
        break;
        
        case IO_P20:
        {
			P2M1 |=  (1 << (pin & 0xF));
			P2M0 &= ~(1 << (pin & 0xF));;
        }
        break;
        
        case IO_P30:
        {
			P3M1 |=  (1 << (pin & 0xF));
			P3M0 &= ~(1 << (pin & 0xF));
        }
        break;
        
        case IO_P40:
        {
			P4M1 |=  (1 << (pin & 0xF));
			P4M0 &= ~(1 << (pin & 0xF));
        }
        break;
        
        case IO_P50:
        {
			P5M1 |=  (1 << (pin & 0xF));
			P5M0 &= ~(1 << (pin & 0xF));
        }
        break;
        
        default:
        {
			zf_assert(0);
			// û
        } break;
    }
}

//-------------------------------------------------------------------------------------------------------------------
//      GPIOʼ
// ˵     pin         ѡ (ѡΧ common.h GPIO_PIN_enumöֵȷ)
// ˵     dir         ŵķ   GPO   룺GPI
// ˵     dat         ųʼʱõĵƽ״̬ʱЧ 0͵ƽ 1ߵƽ
// ˵     pinconf     ãòzf_gpio.hļGPIOSPEED_enumGPIOMODE_enumöֵȷʹ | 
// ز     void
// ʹʾ     gpio_init(D0, GPO, 1, GPIO_PIN_CONFIG);//D0ʼΪGPIOܡģʽߵƽٶ100MHZ 
//-------------------------------------------------------------------------------------------------------------------
void gpio_init(gpio_pin_enum pin, gpio_dir_enum dir, const uint8 dat, gpio_mode_enum mode)
{
	zf_assert(dir == (mode >> 4));

	if(dir == GPIO)
	{
		gpio_set_dir(pin, GPIO);
		gpio_set_mode(pin, mode);
	}
	else if(dir == GPI)
	{
		if(mode == GPI_IMPEDANCE)
		{
			gpio_set_impedance(pin);
		}
		else
		{
			gpio_set_dir(pin, GPI);
			gpio_set_mode(pin, mode);
		}
	}
	else if(dir == GPO)
	{
		if(GPO_PUSH_PULL == mode)
		{
			gpio_set_dir(pin, GPO);
			gpio_set_mode(pin, GPI_PULL_UP);
		}
		else if(GPO_OPEN_DTAIN == mode)
		{
			gpio_set_mode(pin, GPO_OPEN_DTAIN);
		}
	}
	gpio_set_level(pin, dat);
}

