/*********************************************************************************************************************
* AI8051U Opensourec Library AI8051U Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļSTC Դһ
*
* AI8051U Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MDK FOR C251
* ƽ̨          AI8051U
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                          ע
* 2024-08-01        W            first version
********************************************************************************************************************/

#include "zf_common_clock.h"
#include "zf_common_debug.h"

#include "zf_driver_pwm.h"
#include "zf_driver_gpio.h"
#include "zf_driver_uart.h"




// ȽģʽĴ
const uint32 PWM_CCMR_ADDR[] = {0x7efec8, 0x7efec9, 0x7efeca, 0x7efecb,
                                0x7efee8, 0x7efee9, 0x7efeea, 0x7efeeb
                               };

// ȽʹܼĴ
const uint32 PWM_CCER_ADDR[] = {0x7efecc, 0x7efecd,		// PWMA_CCERX
                                0x7efeec, 0x7efeed
                               };	// PWMB_CCERX

// ƼĴ,8λַ  8λַ + 1
const uint32 PWM_CCR_ADDR[] = {0x7efed5, 0x7efed7, 0x7efed9, 0x7efedb,
                               0x7efef5, 0x7efef7, 0x7efef9, 0x7efefb
                              };

// ƼĴ,8λַ  8λַ + 1
const uint32 PWM_ARR_ADDR[] = {0x7efed2, 0x7efef2};

// ԤƵĴ,8λַ  8λַ + 1
const uint32 PWM_PSCR_ADDR[] = {0x7efed0, 0x7efef0};


#define PWMX_CCERX(pin)		(*(unsigned char volatile far *)(PWM_CCER_ADDR[((pin >> 12 & 0x02) >> 1) + ((pin >> 15 & 0x1) * 2)]))

#define PWMX_CCRXH(pin)		(*(unsigned char volatile far *)(PWM_CCR_ADDR[((pin >> 15 & 0x1) * 4) + (pin >> 12 & 0x7)]))
#define PWMX_CCRXL(pin)		(*(unsigned char volatile far *)(PWM_CCR_ADDR[((pin >> 15 & 0x1) * 4) + (pin >> 12 & 0x7)] + 1))

#define PWMX_ARRH(pin)		(*(unsigned char volatile far *)(PWM_ARR_ADDR[(pin >> 15 & 0x1) * 1]))
#define PWMX_ARRL(pin)		(*(unsigned char volatile far *)(PWM_ARR_ADDR[(pin >> 15 & 0x1) * 1] + 1))

#define PWMX_PSCRH(pin)		(*(unsigned char volatile far *)(PWM_PSCR_ADDR[(pin >> 15 & 0x1) * 1]))
#define PWMX_PSCRL(pin)		(*(unsigned char volatile far *)(PWM_PSCR_ADDR[(pin >> 15 & 0x1) * 1] + 1))

#define PWMX_CCMRX(pin)		(*(unsigned char volatile far *)(PWM_CCMR_ADDR[((pin >> 15 & 0x1) * 4) + (pin >> 12 & 0x7)]))


//-------------------------------------------------------------------------------------------------------------------
//      PWMƵʺռձ
// ˵     pin           	PWMͨż
// ˵     freq           	PWMƵ
// ˵     duty            	PWMռձ
// ز     void
// ʹʾ     pwm_set_freq(PWMB_CH1_P01, 50, 1000);   //PWMB ʹP01 Ƶ50HZ ռձΪٷ֮ 1000/PWM_DUTY_MAX*100
//                              						PWM_DUTY_MAXzf_driver_pwm.hļ ĬΪ10000
//-------------------------------------------------------------------------------------------------------------------
void pwm_set_freq(pwm_channel_enum pin, uint32 freq, uint32 duty)
{
    uint32 match_temp = 0;
    uint32 period_temp = 0;
    uint16 freq_div = 0;
	
	// һб ȥռձ޶Ķ ռձд
    zf_assert(PWM_DUTY_MAX >= duty);
	
    //Ƶ㣬ڼ㣬ռձȼ
    freq_div = (system_clock / freq) >> 16;								// ٷƵ
    period_temp = system_clock / freq;
    period_temp = period_temp / (freq_div + 1) - 1;					// 

    if(duty != PWM_DUTY_MAX)
    {
        match_temp = period_temp * ((float)duty / PWM_DUTY_MAX);	// ռձ
    }
    else
    {
        match_temp = period_temp + 1;								// dutyΪ100%
	}

	PWMX_PSCRH(pin) = (uint8)(freq_div >> 8);	    // ԤƵֵ
	PWMX_PSCRL(pin) = (uint8)freq_div;
	
	PWMX_ARRH(pin) = (uint8)(period_temp >> 8);		// ֵ 8λ
	PWMX_ARRL(pin) = (uint8)period_temp;			// ֵ 8λ

    PWMX_CCRXH(pin) = match_temp >> 8;				// Ƚֵ 8λ
    PWMX_CCRXL(pin) = (uint8)match_temp;			// Ƚֵ 8λ
}

//-------------------------------------------------------------------------------------------------------------------
//      PWMռձ趨
// ˵     pwmch           PWMͨż
// ˵     duty            PWMռձ
// ز     void
// ʹʾ     pwm_set_duty(PWMB_CH1_P01, 5000);   //PWMB ʹP01 ռձΪٷ֮ 5000/PWM_DUTY_MAX*100
//                              					PWM_DUTY_MAXzf_driver_pwm.hļ ĬΪ10000
//-------------------------------------------------------------------------------------------------------------------
void pwm_set_duty(pwm_channel_enum pin, uint32 duty)
{
    uint32 match_temp;
    uint32 arr = (PWMX_ARRH(pin) << 8) | PWMX_ARRL(pin);
	
	// һб ȥռձ޶Ķ ռձд
    zf_assert(PWM_DUTY_MAX >= duty);
	
    if(duty != PWM_DUTY_MAX)
    {
        match_temp = arr * ((float)duty / PWM_DUTY_MAX);				//ռձ
    }
    else
    {
        match_temp = arr + 1;
    }

    //òֵ|Ƚֵ
    PWMX_CCRXH(pin) = match_temp >> 8;				// Ƚֵ 8λ
    PWMX_CCRXL(pin) = (uint8)match_temp;			// Ƚֵ 8λ
	
}

//-------------------------------------------------------------------------------------------------------------------
//      PWMʼ
// ˵     pin				PWMͨż
// ˵     freq            PWMƵ
// ˵     duty            PWMռձ
// ز     void
// ʹʾ     pwm_init(PWMB_CH1_P01, 50, 5000);   //ʼPWMB ʹP01  PWMƵ50HZ   ռձΪٷ֮ 5000/PWM_DUTY_MAX*100
//                              					PWM_DUTY_MAXzf_driver_pwm.hļ ĬΪ10000
//-------------------------------------------------------------------------------------------------------------------
void pwm_init(pwm_channel_enum pin, uint32 freq, uint32 duty)
{

    uint16 match_temp = 0;                                              // ռձֵ
    uint32 period_temp = 0;                                             // ֵ
    uint16 freq_div = 0;                                                // Ƶֵ
    
	// һб ȥռձ޶Ķ ռձд
    zf_assert(PWM_DUTY_MAX >= duty);
	
    gpio_init(pin  & 0xFF, GPO, 1, GPO_PUSH_PULL);							// GPIOҪΪ
    
    
    //Ƶ㣬ڼ㣬ռձȼ
    freq_div = (system_clock / freq) >> 16;								// Ƶֵ
    period_temp = system_clock / freq;
    period_temp = period_temp / (freq_div + 1) - 1;						// ֵ
	
    if(duty != PWM_DUTY_MAX)
    {		
        match_temp = period_temp * ((float)duty / PWM_DUTY_MAX);		// ռձ
    }
    else
    {
        match_temp = period_temp + 1;									// dutyΪ100%
    }

	PWMX_PSCRH(pin) = (uint8)(freq_div >> 8);	    // ԤƵֵ
	PWMX_PSCRL(pin) = (uint8)freq_div;
	
	PWMX_ARRH(pin) = (uint8)(period_temp >> 8);		// ֵ 8λ
	PWMX_ARRL(pin) = (uint8)period_temp;			// ֵ 8λ

    PWMX_CCRXH(pin) = (uint8)(match_temp >> 8);		// Ƚֵ 8λ
    PWMX_CCRXL(pin) = (uint8)match_temp;			// Ƚֵ 8λ
	
    if(((pin >> 15) & 0x01) == 0)					// PWMA
    {
        PWMA_ENO |= 1 << ((((pin >> 12) & 0x07) * 2) + ((pin >> 11) & 0x01));		// ʹͨ
        PWMA_PS  |= ((pin >> 9) & 0x03) << (((pin >> 12) & 0x07) * 2);				// ѡ
        PWMX_CCERX(pin) |= 1 << ((pin >> 12 & 0x01) * 4 + (pin >> 11 & 0x01) * 2);	// 

        PWMA_BKR = 0x80; 							// ʹ ൱ܿ
        PWMA_CR1 = 0x01;							// PWMʼ
    }
    else if(((pin >> 15) & 0x01) == 1)				// PWMB
    {
        PWMB_ENO |= 1 << ((((pin >> 12) & 0x07) * 2) + ((pin >> 11) & 0x01));		// ʹͨ
        PWMB_PS  |= ((pin >> 9) & 0x03) << (((pin >> 12) & 0x07) * 2);				// ѡ
        PWMX_CCERX(pin) |= 1 << ((pin >> 12 & 0x01) * 4);							// 

        PWMB_BKR = 0x80; 							// ʹ ൱ܿ
        PWMB_CR1 = 0x01;							// PWMʼ
    }

	PWMX_CCMRX(pin) |= 0x06 << 4;					// ΪPWMģʽ1
	PWMX_CCMRX(pin) |= 1 << 3;						// PWMĴԤװع
}
