/*********************************************************************************************************************
* AI8051U Opensourec Library AI8051U Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļSTC Դһ
*
* AI8051U Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MDK FOR C251
* ƽ̨          AI8051U
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                          ע
* 2024-08-01        W            first version
********************************************************************************************************************/

#ifndef __ZF_DRIVER_PWM_H
#define __ZF_DRIVER_PWM_H
#include "zf_common_typedef.h"
#include "zf_driver_gpio.h"



// 16λ
// BIT[15] 		: 0->PWMA 1->PWMB
// BIT[14:12]  	: 0->CH1 1->CH2 2->CH3 3->CH4 4->CH5 5->CH6
// BIT[11]		: 0->P 1->N
// BIT[10:9]	: 0->PS0 1->PS1 2->PS2 3->PS3
// BIT[7:0]		: IO_PIN
	
typedef enum
{
    // PWMAPWMB鲻ͬPWM
    
    // PWMAͨʼֻһƵ
    // ͬһPWMͬһʱֻ̣ͬһPWM
    // :PWMA_CH1P_P10  PWMA_CH1N_P11һ
	// ǲͬͨͬһʱ
    // :PWMA_CH1P_P10  PWMA_CH2N_P03 ͬʱ
    PWMA_CH1P_P10 = 0<<15|0<<12|0<<11|0<<9|IO_P10, PWMA_CH1N_P11 = 0<<15|0<<12|1<<11|0<<9|IO_P11,
    PWMA_CH1P_P00 = 0<<15|0<<12|0<<11|1<<9|IO_P10, PWMA_CH1N_P01 = 0<<15|0<<12|1<<11|1<<9|IO_P01,
    PWMA_CH1P_P20 = 0<<15|0<<12|0<<11|2<<9|IO_P10, PWMA_CH1N_P21 = 0<<15|0<<12|1<<11|2<<9|IO_P21,
																	
    PWMA_CH2P_P12 = 0<<15|1<<12|0<<11|0<<9|IO_P12, PWMA_CH2N_P13 = 0<<15|1<<12|1<<11|0<<9|IO_P13,
    PWMA_CH2P_P02 = 0<<15|1<<12|0<<11|1<<9|IO_P02, PWMA_CH2N_P03 = 0<<15|1<<12|1<<11|1<<9|IO_P03,
    PWMA_CH2P_P22 = 0<<15|1<<12|0<<11|2<<9|IO_P22, PWMA_CH2N_P23 = 0<<15|1<<12|1<<11|2<<9|IO_P23,
																		 
    PWMA_CH3P_P14 = 0<<15|2<<12|0<<11|0<<9|IO_P14, PWMA_CH3N_P15 = 0<<15|2<<12|1<<11|0<<9|IO_P15,
    PWMA_CH3P_P04 = 0<<15|2<<12|0<<11|1<<9|IO_P04, PWMA_CH3N_P05 = 0<<15|2<<12|1<<11|1<<9|IO_P05,
    PWMA_CH3P_P24 = 0<<15|2<<12|0<<11|2<<9|IO_P24, PWMA_CH3N_P25 = 0<<15|2<<12|1<<11|2<<9|IO_P25,
																
    PWMA_CH4P_P16 = 0<<15|3<<12|0<<11|0<<9|IO_P16, PWMA_CH4N_P17 = 0<<15|3<<12|1<<11|0<<9|IO_P17,
    PWMA_CH4P_P06 = 0<<15|3<<12|0<<11|1<<9|IO_P06, PWMA_CH4N_P07 = 0<<15|3<<12|1<<11|1<<9|IO_P07,
    PWMA_CH4P_P26 = 0<<15|3<<12|0<<11|2<<9|IO_P26, PWMA_CH4N_P27 = 0<<15|3<<12|1<<11|2<<9|IO_P27,

//	PWMA_CH5_P33  = 0x040000 | IO_P33,
//	PWMA_CH5_P44  = 0x040100 | IO_P44,
//	PWMA_CH5_P56  = 0x040200 | IO_P56,
//		
//	PWMA_CH6_P34  = 0x050000 | IO_P34,
//	PWMA_CH6_P47  = 0x050100 | IO_P47,
//	PWMA_CH6_P57  = 0x050200 | IO_P57,

    // PWMAͨʼֻһƵ
    // ͬһPWMͬһʱֻ̣ͬһPWM
    // :PWMB_CH1_P01  PWMB_CH1_P21 ͬʱ
    // ǲͬͨͬһʱ
    // :PWMB_CH1_P01  PWMB_CH2_P13 ͬʱ
    PWMB_CH1_P01 = 1<<15|0<<12|0<<11|0<<9|IO_P01,
    PWMB_CH1_P11 = 1<<15|0<<12|0<<11|1<<9|IO_P11,
    PWMB_CH1_P21 = 1<<15|0<<12|0<<11|2<<9|IO_P21,
    PWMB_CH1_P50 = 1<<15|0<<12|0<<11|3<<9|IO_P50,

    PWMB_CH2_P03 = 1<<15|1<<12|0<<11|0<<9|IO_P03,
    PWMB_CH2_P13 = 1<<15|1<<12|0<<11|1<<9|IO_P13,
    PWMB_CH2_P23 = 1<<15|1<<12|0<<11|2<<9|IO_P23,
    PWMB_CH2_P51 = 1<<15|1<<12|0<<11|3<<9|IO_P51,

    PWMB_CH3_P05 = 1<<15|2<<12|0<<11|0<<9|IO_P05,
    PWMB_CH3_P15 = 1<<15|2<<12|0<<11|1<<9|IO_P15,
    PWMB_CH3_P25 = 1<<15|2<<12|0<<11|2<<9|IO_P25,
    PWMB_CH3_P52 = 1<<15|2<<12|0<<11|3<<9|IO_P52,

    PWMB_CH4_P07 = 1<<15|3<<12|0<<11|0<<9|IO_P07,
    PWMB_CH4_P17 = 1<<15|3<<12|0<<11|1<<9|IO_P17,
    PWMB_CH4_P27 = 1<<15|3<<12|0<<11|2<<9|IO_P27,
    PWMB_CH4_P53 = 1<<15|3<<12|0<<11|3<<9|IO_P53,
    
} pwm_channel_enum;



#define PWM_DUTY_MAX 10000

void    pwm_set_duty    (pwm_channel_enum pin, uint32 duty);
void    pwm_set_freq    (pwm_channel_enum pin, uint32 freq, uint32 duty);
void    pwm_init        (pwm_channel_enum pin, uint32 freq, uint32 duty);

#endif
