/*********************************************************************************************************************
* AI8051U Opensourec Library AI8051U Դ⣩һڹٷ SDK ӿڵĵԴ
* Copyright (c) 2022 SEEKFREE ɿƼ
*
* ļSTC Դһ
*
* AI8051U Դ 
* Ըᷢ GPLGNU General Public License GNUͨù֤
*  GPL ĵ3棨 GPL3.0ѡģκκİ汾·/޸
*
* Դķϣܷãδκεı֤
* ûԻʺض;ı֤
* ϸμ GPL
*
* ӦյԴͬʱյһ GPL ĸ
* ûУ<https://www.gnu.org/licenses/>
*
* ע
* Դʹ GPL3.0 Դ֤Э Ϊİ汾
* Ӣİ libraries/doc ļµ GPL3_permission_statement.txt ļ
* ֤ libraries ļ ļµ LICENSE ļ
* ӭλʹò ޸ʱ뱣ɿƼİȨ
*
* ļ          
* ˾          ɶɿƼ޹˾
* 汾Ϣ          鿴 libraries/doc ļ version ļ 汾˵
*           MDK FOR C251
* ƽ̨          AI8051U
*           https://seekfree.taobao.com/
*
* ޸ļ¼
*                          ע
* 2024-08-01        W            first version
********************************************************************************************************************/

#include "stdlib.h"
#include "zf_common_clock.h"
#include "zf_common_debug.h"

#include "zf_driver_uart.h"
#include "zf_driver_timer.h"
#include "zf_driver_gpio.h"

uint8 xdata uart_rx_buff[UART_RESERVE][1] = {0};

#define DMA_URXT_CFG(uart_n)		(*(unsigned char volatile far *)(0x7efa30 + uart_n*0x10))
#define DMA_URXT_CR(uart_n)     	(*(unsigned char volatile far *)(0x7efa31 + uart_n*0x10))
#define DMA_URXT_STA(uart_n)    	(*(unsigned char volatile far *)(0x7efa32 + uart_n*0x10))
#define DMA_URXT_AMT(uart_n)    	(*(unsigned char volatile far *)(0x7efa33 + uart_n*0x10))
#define DMA_URXT_DONE(uart_n)   	(*(unsigned char volatile far *)(0x7efa34 + uart_n*0x10))
#define DMA_URXT_TXAH(uart_n)   	(*(unsigned char volatile far *)(0x7efa35 + uart_n*0x10))
#define DMA_URXT_TXAL(uart_n)   	(*(unsigned char volatile far *)(0x7efa36 + uart_n*0x10))
#define DMA_URXR_CFG(uart_n)    	(*(unsigned char volatile far *)(0x7efa38 + uart_n*0x10))
#define DMA_URXR_CR(uart_n)     	(*(unsigned char volatile far *)(0x7efa39 + uart_n*0x10))
#define DMA_URXR_STA(uart_n)    	(*(unsigned char volatile far *)(0x7efa3a + uart_n*0x10))
#define DMA_URXR_AMT(uart_n)    	(*(unsigned char volatile far *)(0x7efa3b + uart_n*0x10))
#define DMA_URXR_DONE(uart_n)   	(*(unsigned char volatile far *)(0x7efa3c + uart_n*0x10))
#define DMA_URXR_RXAH(uart_n)   	(*(unsigned char volatile far *)(0x7efa3d + uart_n*0x10))
#define DMA_URXR_RXAL(uart_n)   	(*(unsigned char volatile far *)(0x7efa3e + uart_n*0x10))

#define DMA_URXT_AMTH(uart_n)   	(*(unsigned char volatile far *)(0x7efa88 + uart_n*0x04))
#define DMA_URXT_DONEH(uart_n)  	(*(unsigned char volatile far *)(0x7efa89 + uart_n*0x04))
#define DMA_URXR_AMTH(uart_n)   	(*(unsigned char volatile far *)(0x7efa8a + uart_n*0x04))
#define DMA_URXR_DONEH(uart_n)  	(*(unsigned char volatile far *)(0x7efa8b + uart_n*0x04))


// ֹ޸ģڲʹ,û
static uart_function_enum uart_function_state[4] =
{
    UART_FUNCTION_INIT,
    UART_FUNCTION_INIT,
    UART_FUNCTION_INIT,
    UART_FUNCTION_INIT,
};

//-------------------------------------------------------------------------------------------------------------------
//      UART ȷϹ״̬ ڲ
// ˵     index           UART ģ
// ˵     mode            ҪȷĹģ
// ز     uint8           1-ʹ 0-ʹ
// ʹʾ     zf_assert(uart_funciton_check(UART_2, UART_FUNCTION_UART));
//-------------------------------------------------------------------------------------------------------------------
uint8 uart_funciton_check (uart_index_enum index, uart_function_enum mode)
{
    uint8 return_state = 1;
    if(UART_FUNCTION_INIT == uart_function_state[index])
    {
        uart_function_state[index] = mode;
    }
    else if(uart_function_state[index] == mode)
    {
        return_state = 1;
    }
    else
    {
        return_state = 0;
    }
    return return_state;
}
//-------------------------------------------------------------------------------------------------------------------
//      ڷ
// ˵     uart_n       ͨ
// ˵     buff        Ҫ͵ַ
// ˵     len         ݳ
// ز     void
// ʹʾ     uart_write_buffer(UART_1, buff, 10);     //110buff顣
//-------------------------------------------------------------------------------------------------------------------
void uart_write_buffer(uart_index_enum uart_n, const uint8 *buff, uint16 len)
{

//	DMA_URXT_CFG(uart_n)  = 0x00; 			// DMAȼ
	DMA_URXT_STA(uart_n) = 0;				// ձ־λ
	len = len - 1;
	DMA_URXT_AMT(uart_n)  = len & 0xff;		// ôֽ(8λ)n+1
	DMA_URXT_AMTH(uart_n) = len >> 8;		// ôֽ(8λ)n+1
	DMA_URXT_TXAH(uart_n) = (uint8)((uint16)buff >> 8);
	DMA_URXT_TXAL(uart_n) = (uint8)((uint16)buff);
	DMA_URXT_CR(uart_n) = 0xC0; 			// ʹDMA TX

	while(!(DMA_URXT_STA(uart_n) & 0x01));	// ȴ

	DMA_URXT_CR(uart_n) = 0x00;				// رDMA TX

}
//-------------------------------------------------------------------------------------------------------------------
//      ڷַ
// ˵     uart_n       ͨ
// ˵     str         ַ׵ַ
// ز     void
// ʹʾ     uart_putstr(UART_1, (uint8 *)"12345")   //112345ַ
//-------------------------------------------------------------------------------------------------------------------
void uart_write_string(uart_index_enum uart_n, const char *str)
{
	#define BUFF_LEN 256
	
    uint16 len = strlen(str);
	// UART_DMAֻܲxdataݣԣ½һ飬ơ
	uint8 buff[BUFF_LEN];

	if(len <= BUFF_LEN)
	{
		memcpy(buff, str, len);
		uart_write_buffer(uart_n, buff, len);
	}
}

//-------------------------------------------------------------------------------------------------------------------
//      ڷһֽ
// ˵     uart_n       ͨ
// ˵     dat         
// ز     void
// ʹʾ     uart_write_byte(UART_1, 0x43);        //10x43
//-------------------------------------------------------------------------------------------------------------------
void uart_write_byte(uart_index_enum uart_n, const uint8 dat)
{
    uart_write_buffer(uart_n, &dat, 1);
}

//-------------------------------------------------------------------------------------------------------------------
//      ڿʼ
// ˵     uart_n       ͨ
// ز     void
// ʹʾ     uart_rx_start_buff(UART_1);
//-------------------------------------------------------------------------------------------------------------------
void uart_rx_start_buff(uart_index_enum uart_n)
{
    DMA_URXR_AMT(uart_n) = (1 - 1);										// ýյֽ
    DMA_URXR_AMTH(uart_n) = (1 - 1) >> 8;								// ýյֽ
    DMA_URXR_RXAL(uart_n) = (uint8)((uint16)uart_rx_buff[uart_n]);		// ýջַ
    DMA_URXR_RXAH(uart_n) = (uint8)((uint16)uart_rx_buff[uart_n] >> 8);	// ýջַ
    DMA_URXR_CR(uart_n) = 0xA1;											// DMA RXжϣDMA RXգFIFO
}



//-------------------------------------------------------------------------------------------------------------------
//      򿪴ڽж
// ˵     uart_n       ͨ
// ˵     status      ʹܻʧ
// ز     void
// ʹʾ     uart_rx_irq(UART_1, ENABLE);        //򿪴1ж
//-------------------------------------------------------------------------------------------------------------------
void uart_rx_interrupt (uart_index_enum uart_n, uint8 status)
{
	if(status)
	{
		DMA_URXR_CFG(uart_n) |= 0x80;
	}
	else
	{
		DMA_URXR_CFG(uart_n) &= ~0x80;
	} 
}

//-------------------------------------------------------------------------------------------------------------------
//      ȡڽյݣwhlieȴ
// ˵     uart_n           ģ(UART_1 - UART_4)
// ˵     *dat            ݵĵַ
// ز     void
// ʹʾ     dat = uart_read_byte(USART_1);       // մ1  dat
//-------------------------------------------------------------------------------------------------------------------
uint8 uart_read_byte(uart_index_enum uart_n)
{
	uint8 dat;
	
	// ȴ
	while(!(DMA_URXR_STA(uart_n)&0x03));

	// ȡ
	dat = uart_rx_buff[uart_n][0];
		
	// ձ־λ
	DMA_URXR_STA(uart_n) = 0x00;
	
	// ʼһν
	uart_rx_start_buff(uart_n);
	return dat;
}

//-------------------------------------------------------------------------------------------------------------------
//      ȡڽյݣѯգ
// ˵     uart_n           ģ(UART_1 - UART_8)
// ˵     *dat            ݵĵַ
// ز     uint8           1ճɹ   0δյ
// ʹʾ     uint8 dat; uart_query_byte(USART_1,&dat);       // մ1  dat
//-------------------------------------------------------------------------------------------------------------------
uint8 uart_query_byte(uart_index_enum uart_n, uint8 *dat)
{
	uint8 ret = 0; 

	// ȡ
	*dat = uart_rx_buff[uart_n][0];
	
	if(DMA_URXR_STA(uart_n) & 0x03)
	{
		ret = 1;
		
		DMA_URXR_STA(uart_n) &= ~0x03;
	}
	else
	{
		ret = 0;
	}
	
	// ʼһν
	uart_rx_start_buff(uart_n);

	return ret;
}

//-------------------------------------------------------------------------------------------------------------------
//      DMAʼ
// ˵     uart_n       ͨ
// ز     void
// ʹʾ     uart_dma_init(UART_1);
//-------------------------------------------------------------------------------------------------------------------
void uart_dma_init(uart_index_enum uart_n)
{
	DMA_URXT_CFG(uart_n)  = 0x00;	// DMA TXݷȼͣرDMAжϣ
	DMA_URXT_STA(uart_n)  = 0x00;	// DMA TX״̬
	DMA_URXT_CR(uart_n)   = 0x00;	// رDMA TX
		
	DMA_URXR_CFG(uart_n)  = 0x00;	// رDMAж
	DMA_URXR_STA(uart_n)  = 0x00;	// DMA RX״̬
	DMA_URXR_CR(uart_n)   = 0x00;	// رDMA RX

	DMA_URXR_AMT(uart_n)  = (1 - 1);									// ýյֽ
	DMA_URXR_AMTH(uart_n) = (1 - 1)>>8;									// ýյֽ
	DMA_URXR_RXAL(uart_n) = (uint8)((uint16)uart_rx_buff[uart_n]);		// ýջַ
	DMA_URXR_RXAH(uart_n) = (uint8)((uint16)uart_rx_buff[uart_n] >> 8);	// ýջַ
	DMA_URXR_CFG(uart_n)  = 0x0F;										// жȼߣDMAȼ
	DMA_URXR_CR(uart_n)   = 0xA1;										// DMA RXFIFO
 
}

//-------------------------------------------------------------------------------------------------------------------
//      ڳʼ
// ˵     uart_n       ͨ
// ˵     baud        
// ˵     tx_pin      ڷź
// ˵     rx_pin      ڽź
// ز     void
// ʹʾ     uart_init(UART_2, 115200, UART2_TX_P11, UART2_RX_P10); //2ʼź,TXΪP11,RXΪP10
// עϢ     еĴڣֻʹöʱ2 ʷеĴֻͬһʡ
//-------------------------------------------------------------------------------------------------------------------
void uart_init(uart_index_enum uart_n, uint32 baud, uart_pin_enum tx_pin, uart_pin_enum rx_pin)
{
    uint16 brt;
    
	// ˶Ϣ ʾλ
    // ȥ鿴ʲôط Ĵ
    // ǼǷظʹUART1  UART2
    // ʼ UART1 Ȼֳʼ SPI1 ÷ǲ
	// UART1SPI1ʹͬһĴҪôUART1ҪôʹSPI1,ֻǶѡһ
	// UART2SPI2ʹͬһĴҪôUART2ҪôʹSPI2,ֻǶѡһ
    zf_assert(uart_funciton_check(uart_n, UART_FUNCTION_UART));
	
	    
	// ˶Ϣ ʾλ
    // ȥ鿴ʲôط Ĵ
    // ǼǷظʹöʱ
	// TIM2ѾʷˡٳʼΪġ
	zf_assert(timer_funciton_check(TIM_2, TIMER_FUNCTION_UART));
	
	
	// ڵRXTXһлб
	// ˵ѡͬһ
	zf_assert(((tx_pin >> 8) & 0x0f) == ((rx_pin >> 8) & 0x0f));
	
	// ʼGPIO
	gpio_init(tx_pin&0xFF, GPO, 1, GPO_PUSH_PULL);
	gpio_init(rx_pin&0xFF, GPI, 1, GPI_FLOATING_IN);
	
    brt = (uint16)(65536 - (system_clock / (baud + 2) / 4));
    
    switch(uart_n)
    {
        case UART_1:
        {
            //            if(TIM_1 == tim_n)
            //            {
            //                SCON |= 0x50;
            //                TMOD |= 0x00;
            //                TL1 = brt;
            //                TH1 = brt >> 8;
            //                AUXR |= 0x40;
            //                TR1 = 0;	//رշж
            //
            //            }
            //            else if(TIM_2 == tim_n)
            {
                SCON |= 0x50;
                T2L = brt;
                T2H = brt >> 8;
                AUXR |= 0x15;
                TR1 = 0;	//رշж
            }
            
            P_SW1 &= ~(0x03 << 6);
            
            if((UART1_RX_P30 == rx_pin) && (UART1_TX_P31 == tx_pin))
            {
                P_SW1 |= 0x00;
            }
            else if((UART1_RX_P36 == rx_pin) && (UART1_TX_P37 == tx_pin))
            {
                P_SW1 |= 0x40;
            }
            else if((UART1_RX_P16 == rx_pin) && (UART1_TX_P17 == tx_pin))
            {
                P_SW1 |= 0x80;
            }
            else if((UART1_RX_P43 == rx_pin) && (UART1_TX_P44 == tx_pin))
            {
                P_SW1 |= 0xc0;
            }
            
            //            ES = 1;	//п1ж
            break;
        }
        
        case UART_2:
        {
            //            if(TIM_2 == tim_n)
            {
                S2CON |= 0x50;
                T2L = brt;
                T2H = brt >> 8;
                AUXR |= 0x14;
            }
            
            P_SW2 &= ~(0x01 << 0);
            
            if((UART2_RX_P12 == rx_pin) && (UART2_TX_P13 == tx_pin))
            {
                P_SW2 |= 0x00;
            }
            else if((UART2_RX_P42 == rx_pin) && (UART2_TX_P43 == tx_pin))
            {
                P_SW2 |= 0x01;
            }
            
            //            IE2 |= 0x01 << 0;	//п2ж
            
            break;
        }
        
        case UART_3:
        {
            //            if(TIM_2 == tim_n)
            {
                S3CON |= 0x10;
                T2L = brt;
                T2H = brt >> 8;
                AUXR |= 0x14;
            }
            //            else if(TIM_3 == tim_n)
            //            {
            //                S3CON |= 0x50;
            //                T3L = brt;
            //                T3H = brt >> 8;
            //                T4T3M |= 0x0a;
            //            }
            
            P_SW2 &= ~(0x01 << 1);
            
            if((UART3_RX_P00 == rx_pin) && (UART3_TX_P01 == tx_pin))
            {
                P_SW2 |= 0x00;
            }
            else if((UART3_RX_P50 == rx_pin) && (UART3_TX_P51 == tx_pin))
            {
                P_SW2 |= 0x02;
            }
            
            //            IE2 |= 0x01 << 3;	//п3ж
            
            break;
        }
        
        case UART_4:
        {
            //            if(TIM_2 == tim_n)
            {
                S4CON |= 0x10;
                T2L = brt;
                T2H = brt >> 8;
                AUXR |= 0x14;
            }
            //            else if(TIM_4 == tim_n)
            //            {
            //                S4CON |= 0x50;
            //                T4L = brt;
            //                T4H = brt >> 8;
            //                T4T3M |= 0xa0;
            //            }
            
            P_SW2 &= ~(0x01 << 2);
            
            if((UART4_RX_P02 == rx_pin) && (UART4_TX_P03 == tx_pin))
            {
                P_SW2 |= 0x00;
            }
            else if((UART4_RX_P52 == rx_pin) && (UART4_TX_P53 == tx_pin))
            {
//                P5M0 = 0x00;
//                P5M1 = 0x01 << 2; //P5.2 ҪΪ
                P_SW2 |= 0x04;
            }
            
            //            IE2 |= 0x01 << 4;	//п4ж
            
            break;
        }
        
    }
    
	// uart dma ʼ
    uart_dma_init(uart_n);
    
}
